/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-    */
/* ex: set filetype=cpp softtabstop=4 shiftwidth=4 tabstop=4 cindent expandtab: */

/*
  $Id: cscSpeechToCommandsQtWidget.h 2936 2011-04-19 16:32:39Z mkelly9 $

  Author(s):  Anton Deguet, Martin Kelly
  Created on: 2011-03-07

  (C) Copyright 2011 Johns Hopkins University (JHU), All Rights Reserved.

--- begin cisst license - do not edit ---

This software is provided "as is" under an open source license, with
no warranty.  The complete license can be found in license.txt and
http://www.cisst.org/cisst/license.txt.

--- end cisst license ---
*/

#ifndef _cscSpeechToCommandsQtWidget_h
#define _cscSpeechToCommandsQtWidget_h

#include <QGridLayout>
#include <QLabel>
#include <QMultiMap>
#include <QWidget>


// Always include last!
#include <cisstSpeechToCommands/cscExportQt.h>
class CISST_EXPORT cscSpeechToCommandsQtWidget : public QWidget
{
    Q_OBJECT;

 public:
    cscSpeechToCommandsQtWidget(void);
    ~cscSpeechToCommandsQtWidget(void) {};

    QMultiMap<QString, QString> ContextMap;

    QGridLayout * CentralLayout;
    QLabel * LabelContext;
    QLabel * ValueContext;
    QLabel * LabelWordRecognized;
    QLabel * ValueWordRecognized;
    QLabel * LabelVocabulary;
    QLabel * ValueVocabulary;

 public slots:
    void AddWord(QString context, QString word);
    void ContextChanged(QString context);

};

#endif  // _cscSpeechToCommandsQtWidget_h
