/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-    */
/* ex: set filetype=cpp softtabstop=4 shiftwidth=4 tabstop=4 cindent expandtab: */

/*
  $Id: cscWordActions.h 2771 2011-03-11 19:45:58Z adeguet1 $

  Author(s):  Martin Kelly, Anton Deguet
  Created on: 2011-02-15

  (C) Copyright 2011 Johns Hopkins University (JHU), All Rights
  Reserved.

--- begin cisst license - do not edit ---

This software is provided "as is" under an open source license, with
no warranty.  The complete license can be found in license.txt and
http://www.cisst.org/cisst/license.txt.

--- end cisst license ---
*/

#ifndef _cscWordActions_h
#define _cscWordActions_h

#include <list>
#include <map>

#include <cisstCommon/cmnGenericObject.h>

// forward declaration
class cscSpeechToCommands;

// Always include last!
#include <cisstSpeechToCommands/cscExport.h>

class CISST_EXPORT cscWordActions: public cmnGenericObject
{
    CMN_DECLARE_SERVICES(CMN_NO_DYNAMIC_CREATION, CMN_LOG_ALLOW_DEFAULT);

    friend class cscContext;

    bool IsTransition;
    std::string EndContext;

 public:
    cscWordActions(void);
    cscWordActions(const std::string & endContext);

    bool PerformActions(cscSpeechToCommands * speechToCommands) const;
};

CMN_DECLARE_SERVICES_INSTANTIATION(cscWordActions);

#endif // _cscWordActions_h
