/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-    */
/* ex: set filetype=cpp softtabstop=4 shiftwidth=4 tabstop=4 cindent expandtab: */

/*
  $Id: SimpleBehavior.h 2448 2011-04-09 15:31:41Z adeguet1 $

  Author(s):	Balazs Vagvolgyi, Simon DiMaio, Anton Deguet
  Created on:	2008-05-23

  (C) Copyright 2008 Johns Hopkins University (JHU), All Rights
  Reserved.

--- begin cisst license - do not edit ---

This software is provided "as is" under an open source license, with
no warranty.  The complete license can be found in license.txt and
http://www.cisst.org/cisst/license.txt.

--- end cisst license ---
*/


#include <cisst3DUserInterface.h>

#include <cisstSpeechToCommands/cscSpeechToCommands.h>

// Always include last!
#include <ui3BehaviorsExport.h>

class CISST_EXPORT VoiceControl: public mtsComponent {
public:

    VoiceControl(const std::string & taskName);
	~VoiceControl() {};

    cscSpeechToCommands * speechToCommands;

protected:  
    void EventContextChangedHandler(const mtsStdString & value);
    void EventWordRecognizedHandler(const mtsStdString & value);
public:
	void Configure(const std::string & CMN_UNUSED(filename) = "");
	void Startup(void) {};
    void Run(void);
    void Cleanup(void) {};

    mtsFunctionVoid measureStart;
    mtsFunctionVoid measureStop;
    mtsFunctionVoid measureExit;

    mtsFunctionVoid mapDisplay;
    mtsFunctionVoid mapAddMarker;
    mtsFunctionVoid mapShow;
    mtsFunctionVoid mapHide;
    mtsFunctionVoid mapExit;
};

